<?php

/*****************************************************************************
Functions to show alternative spellings. For tng mod show all family. DuPree 2019
*****************************************************************************/

function get_last_dad($personID, $tree)
{
Global $people_table, $children_table;
$startpaternal = 1;

$family = get_ldfamilyID ($personID, $tree);
$parents = get_ldparents_of ( $family, $tree);
if ($parents != "")
  {
  $father = $parents["husband"];
  $lastdad = $father;
   }
else
  {
  $father = '';
  $lastdad = '';
  $startpaternal = 100;
  }

if ($father == '' )
{
$MySQL = "SELECT sex FROM $people_table WHERE personID = '" . $personID ."' AND gedcom = '" . $tree . "'";
$Result = tng_query($MySQL);
$Row = mysqli_fetch_assoc($Result);
if ($Row['sex'] == "M" ) $lastdad = $personID;
}

while ($startpaternal < 65 )
{
 if ($father != '')
 {
  $family = get_ldfamilyID ($father, $tree);
  $parents = get_ldparents_of ($family, $tree);
  if ($parents != "" AND $parents['husband'] != '' )
  	  {
      $father = $parents["husband"];
      $lastdad = $father;
      } // parents not empty
  else
  	 {
     $lastdad = $father;
     $father = '';
     }
 }	//father not empty
 	$startpaternal = $startpaternal+1;
} //while
return $lastdad;
}

function get_ldfamilyID ($personID, $tree)
{
  Global $people_table, $children_table;
	//do parents
	$MySQL = "SELECT familyid FROM $children_table WHERE personid = '" . $personID ."' AND gedcom = '" . $tree . "' AND (frel = '' or frel = 'birth' or frel ='sealing' ) AND (mrel = '' or mrel = 'birth' or mrel ='sealing' )";
    $Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1)
	{
		$Row = mysqli_fetch_assoc($Result);
		return $Row["familyid"];
	}else
	{
		$MySQL = "SELECT familyid FROM $children_table WHERE personid = '" . $personID ."' AND gedcom = '" . $tree . "' AND (frel = 'adopted' OR frel = 'putative') ";
    	$Result = tng_query($MySQL);
		if (mysqli_num_rows($Result) == 1)
			{
			$Row = mysqli_fetch_assoc($Result);
			return $Row["familyid"];
			}
		else return "";
	}
}

function get_ldparents_of ($FamilyID, $Tree)
{
  global $families_table;
	$MySQL = "SELECT husband, wife FROM $families_table WHERE familyID = '" . $FamilyID ."' AND gedcom = '" . $Tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1)
	{
		$Row = mysqli_fetch_assoc($Result);
		return $Row;
	}else{
		return "";
	}
}

function get_mom_last ($personID, $tree)
{
	global $people_table;
	$MySQL = "SELECT lastname FROM $people_table WHERE personID = '" . $personID ."' AND gedcom = '" . $tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1)
	{
		$Row = mysqli_fetch_assoc($Result);
		$mlast = $Row['lastname'];
//		$mlast = str_replace(' ', '', strtolower($mlast));
		return $mlast;
	}else{
		return "";
	}
}

function get_child_last ($personID, $tree)
{
	global $people_table;
	$MySQL = "SELECT lastname FROM $people_table WHERE personID = '" . $personID ."' AND gedcom = '" . $tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1)
	{
		$Row = mysqli_fetch_assoc($Result);
		$clast = $Row['lastname'];
//		$clast = str_replace(' ', '', strtolower($clast));
		return $clast;
	}else{
		return "";
	}
}


function get_desc_names($personID, $getperson_url, $tree)
{
global $people_table, $children_table;
	$start = 1;
	$checker = '';

	$query = "SELECT sex FROM $people_table WHERE personid = '" . $personID ."' AND gedcom = '" . $tree . "' ";
	$result =  tng_query($query);
	$row = tng_fetch_assoc( $result );
 	if ($row['sex'] = "M") $family = get_pschildrenID ($personID, $tree);

while ($start < 150 )
{
 	foreach ($family as $fams)
		{

	    $query = "SELECT personID, lastname FROM $people_table WHERE sex = 'M' AND personID IN (SELECT personID FROM $children_table WHERE familyID = '" . $fams['familyID'] ."' AND gedcom = '" . $tree . "' AND (frel = '' or frel = 'birth' or frel ='sealing' ) AND (mrel = '' or mrel = 'birth' or mrel ='sealing' ) )  ";
        $result = tng_query($query);
				foreach ($result as $ch)
				{
//				$chkme = str_replace('/', '&', $ch['lastname']);
				$checker .= $checker . '&' . $chkme;
				$fids .= $ch['personID'];
				}
		}

	$start = $start +1;

}

$families = $checker . $fids;

return $families;
}

function get_pschildrenID ($personID, $tree)
{
global $families_table, $children_table;
$query = "SELECT familyID FROM $families_table WHERE husband = '" . $personID ."' AND gedcom = '" . $tree . "' ";
$result = tng_query($query);
return $result;
}

function getMlastnames( $key, $sex, $level, $trail, $dab, $tname ) {
	global $tree, $text, $cms, $righttree;
  $crowchanges = ''; $checkme = ''; $xvar2 = ''; //variables set to null to avoid warning.
$generations = 50;
if ($sex == 'F') return '';
$rval = "";
$self = "husband";
$spouse = "wife";
$spouseorder = "husborder";
$tname2 = $tname . '/';
$notmarried = 'Not Married';
if ($notmarried == '' ) $notmarried = 'x&x';

if( $spouse ) $result = getSpouseFamilyData($tree, $self, $key, $spouseorder);
elseif( $key )$result = getSpouseFamilyDataUnion($tree, $key);
$marrtot = tng_num_rows($result);
if( !$marrtot && $key)
	{
	$result = getSpouseFamilyDataUnion($tree, $key);
	$self = $spouse = $spouseorder = "";
	}

	if( $result ) {
		$childcounter = 0;
		while( $row = tng_fetch_assoc( $result ) ) {
			$spouserow = array();
			$spousestr = "";
			if( !$spouse )
				$spouse = $row['husband'] == $key ? "wife" : "husband";
			if( $row[$spouse] ) {
				$spouseresult = getPersonData($tree, $row[$spouse]);
			}
			$result2 = getChildrenData($tree, $row['familyID']);
			$numkids = tng_num_rows( $result2 );
			if( $numkids AND $row['marrtype'] != $notmarried ) {
				while( $crow = tng_fetch_assoc( $result2 ) ) {
					$childcounter++;
					$newtrail = "$trail,{$row['familyID']},{$crow['personID']}";
					$crights = determineLivingPrivateRights($crow, $righttree);
					$crow['allow_living'] = $crights['living'];
					$crow['allow_private'] = $crights['private'];
					$newdab = $dab . "." . $childcounter;
//					$crowchanged = str_replace(' ', '^^@^^', $crow['lastname'] . $crow['personID']); for troubleshooting
					$stophere = 0;
				//	$xvar = rtrim(tng_strtolower($crow['lastname']), ' ');
					$xvar = $crow['lastname'];
//					$xvar2 = $xvar . '/';
					if (strpos($xvar, '/') !== false ) $xvar = str_replace('/', '&', $xvar);
// echo $xvar2 . ' tname2 ' . $tname2 . ' and $tname ' . $tname . '<br>';
if ($xvar == '' OR $xvar == $tname ) {$stophere == 1; $crowchanged = '';}
else
{
					if (stripos($checkme, $xvar) !== false OR $tname == $xvar OR stripos($xvar2, $tname2) !== false) $stophere = 1;
					   else $checkme .= $xvar . ',';
					$crowchanged = str_replace(' ', '^^@^^', rtrim($crow['lastname'],' '));
}
					if ($stophere != 1 AND $crow['sex'] == 'M' AND ($crow['frel'] == '' OR $crow['frel'] == 'birth' OR $crow['frel'] == 'adopted' ) ) $rval .= '&' . $crowchanged;
					if( $level < $generations AND ($crow['frel'] == '' OR $crow['frel'] == 'birth' OR $crow['frel'] == 'adopted' ) ) {
						$ind = getMlastnames( $crow['personID'], $crow['sex'], $level + 1, $newtrail, $newdab, $tname );
						if($ind) {
							$rval .= str_repeat( "", ($level - 1) * 8 + 2 ) . "$ind";
						}
					}
					else {
						//do union to check for children where person is either husband or wife
						$nxtfams = getSpouseFamilyMinimalUnion($tree, $crow['personID']);
						$nxtkids = 0;
						while($nxtfam = tng_fetch_assoc($nxtfams)) {
							$result3 = countChildren($tree, $nxtfam['familyID']);
							$nxtrow = tng_fetch_assoc($result3);
							$nxtkids += $nxtrow['ccount'];
							tng_free_result($result3);
						}

					}
					$rval .= str_repeat( "", ($level - 1) * 8 );
				}
				if( $numkids ) {
					$rval .= str_repeat( "", ($level - 1) * 8 - 2 );
					$rval .= str_repeat( "", ($level - 1) * 8 - 4 );
				}
			}
			elseif( $spousestr )
				$rval .= str_repeat( "", ($level - 1) * 8 - 4 );
			tng_free_result( $result2 );
		}
	}
	tng_free_result( $result );

	return $rval;
}

function getDlastnames( $personID, $tree, $tname ) {
$check='';
$generations = 50; $level = 1; $key = $personID;
$result = getPersonFullPlusDates($tree, $personID);
if( $result ) $row = tng_fetch_assoc( $result );
if( $generations > 1 ) {
	$ind = getMlastnames( $key, $row['sex'], $level + 1, $personID, "1", $tname );
	if($ind) $check = $ind . ' ';
}
$rowchanged = str_replace(' ', '^^@^^', $row['lastname']);
if ($row['lastname'] != '' )
{
if (strpos($check, $rowchanged) !== false OR strpos(tng_strtolower($row['lastname']), $tname) !== false ) $check = $check;
else $check .= '&' . $rowchanged;
}
// else $check .= '&' . $rowchanged . '-' . $tname . '-' . $row['lastname'];
// $check = $rowchanged;
return $check;
}

function associated_surnames( $personID, $tree, $tname) {
$last = get_last_dad($personID, $tree) ; // gets first paternal ancestor
$anames =''; // set variable
if ($last != '') $anames = getDlastnames( $last, $tree, $tname ); // gets lastnames of all descendants in a string
// Make text string pretty
$anames = str_replace(' ', '', str_replace('/', '&', $anames));
$excludeme = 'unknown';
$anames = str_ireplace($excludeme, '', $anames );
$anames = implode('&', array_unique(explode('&', $anames)));
$anames=explode("&", $anames);
sort($anames);
$anames = implode("&", $anames);
$anames = substr($anames, 1);
$anames = str_replace('&', ', ', $anames);
$anames = str_replace(' ,', ',', $anames);
$anames = str_replace('^^@^^', ' ', $anames);
// $anames = $anames . ' - ' . $last; //useful for troubleshooting
return $anames;
}


?>
